// PicoTestDLL.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "PicoTestDLL.h"

// TODO: Change the path to the pico header
#include <PicoScope\inc\ps6000API.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//TODO: If this DLL is dynamically linked against the MFC DLLs,
//		any functions exported from this DLL which call into
//		MFC must have the AFX_MANAGE_STATE macro added at the
//		very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CPicoTestDLLApp

BEGIN_MESSAGE_MAP(CPicoTestDLLApp, CWinApp)
END_MESSAGE_MAP()


// CPicoTestDLLApp construction

CPicoTestDLLApp::CPicoTestDLLApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CPicoTestDLLApp object

CPicoTestDLLApp theApp;


// CPicoTestDLLApp initialization

BOOL CPicoTestDLLApp::InitInstance()
{
	CWinApp::InitInstance();
	
	// pico initialization
	m_picoHandle = 0;
	PICO_STATUS picoStatus = PICO_OK;

	// pico read driver version
	char szDriverVersion[64] = { 0 };
	short sizeDriverVersion = 0;
	picoStatus = ps6000GetUnitInfo(NULL, (int8_t*)szDriverVersion, _countof(szDriverVersion), &sizeDriverVersion, PICO_DRIVER_VERSION);

	// finding devices installed on PC
	short nEnumCount = 0;
	char szEnumSerials[128] = { 0 };
	short sizeEnumSerials = _countof(szEnumSerials);
	picoStatus = ps6000EnumerateUnits(&nEnumCount, (int8_t*)szEnumSerials, &sizeEnumSerials);
	
	// if one found, open this device
	if (nEnumCount==1)
		picoStatus = ps6000OpenUnit(&m_picoHandle, (int8_t*)szEnumSerials);
		
	return TRUE;
}


BOOL CPicoTestDLLApp::ExitInstance()
{
	CWinApp::ExitInstance();

	// close any opened pico device
	PICO_STATUS picoStatus = PICO_OK;
	if (m_picoHandle > 0) picoStatus = ps6000CloseUnit(m_picoHandle);

	return TRUE;
}